import json

from asgiref.sync import async_to_sync
from channels.layers import get_channel_layer
from django.contrib.auth import get_user_model
from django.contrib.auth.models import Group

channel_layer = get_channel_layer()
User = get_user_model()


def send_message_to_everyone(event: str, message: dict) -> None:
    send_message(['everyone'], event, message)


def send_message(recipients: list, event: str, message: dict) -> None:
    for send in recipients:
        if isinstance(send, Group):
            send = f'group.{send.id}'
        elif isinstance(send, User):
            send = f'user.{send.id}'

        async_to_sync(channel_layer.group_send)(send, dict(
            type="distribute",
            message=json.dumps([event, message])
        ))
